/* tslint:disable */
/* eslint-disable */
/**
 * Swagger Petstore
 * This spec is mainly for testing Petstore server and contains fake endpoints, models. Please do not use this for any other purpose. Special characters: \" \\
 *
 * OpenAPI spec version: 1.0.0
 * Contact: apiteam@swagger.io
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import globalAxios, { AxiosPromise, AxiosInstance } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
import { Animal } from '../models';
/**
 * AnimalApi - axios parameter creator
 * @export
 */
export const AnimalApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Add a new animal to the store
         * @param {Animal} body Animal object that needs to be added to the store
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        addAnimal: async (body: Animal, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'body' is not null or undefined
            if (body === null || body === undefined) {
                throw new RequiredError('body','Required parameter body was null or undefined when calling addAnimal.');
            }
            const localVarPath = `/animal`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication api_key_query required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("api_key_query")
                    : await configuration.apiKey;
                localVarQueryParameter["api_key_query"] = localVarApiKeyValue;
            }

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                query.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Deletes a animal
         * @param {number} animalId Animal id to delete
         * @param {string} [apiKey] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteAnimal: async (animalId: number, apiKey?: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'animalId' is not null or undefined
            if (animalId === null || animalId === undefined) {
                throw new RequiredError('animalId','Required parameter animalId was null or undefined when calling deleteAnimal.');
            }
            const localVarPath = `/animal/{animalId}`
                .replace(`{${"animalId"}}`, encodeURIComponent(String(animalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication api_key_query required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("api_key_query")
                    : await configuration.apiKey;
                localVarQueryParameter["api_key_query"] = localVarApiKeyValue;
            }

            if (apiKey !== undefined && apiKey !== null) {
                localVarHeaderParameter['api_key'] = String(apiKey);
            }

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                query.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * Returns a single animal
         * @summary Find animal by ID
         * @param {number} animalId ID of pet to return
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAnimalById: async (animalId: number, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'animalId' is not null or undefined
            if (animalId === null || animalId === undefined) {
                throw new RequiredError('animalId','Required parameter animalId was null or undefined when calling getAnimalById.');
            }
            const localVarPath = `/animal/{animalId}`
                .replace(`{${"animalId"}}`, encodeURIComponent(String(animalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication api_key_query required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("api_key_query")
                    : await configuration.apiKey;
                localVarQueryParameter["api_key_query"] = localVarApiKeyValue;
            }

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                query.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update an existing animal
         * @param {Animal} body Animal object that needs to be added.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateAnimal: async (body: Animal, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'body' is not null or undefined
            if (body === null || body === undefined) {
                throw new RequiredError('body','Required parameter body was null or undefined when calling updateAnimal.');
            }
            const localVarPath = `/animal`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication api_key_query required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("api_key_query")
                    : await configuration.apiKey;
                localVarQueryParameter["api_key_query"] = localVarApiKeyValue;
            }

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                query.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Updates a animal
         * @param {number} animalId ID of animal that needs to be updated
         * @param {string} [name] 
         * @param {string} [status] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateAnimalWithForm: async (animalId: number, name?: string, status?: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'animalId' is not null or undefined
            if (animalId === null || animalId === undefined) {
                throw new RequiredError('animalId','Required parameter animalId was null or undefined when calling updateAnimalWithForm.');
            }
            const localVarPath = `/animal/{animalId}`
                .replace(`{${"animalId"}}`, encodeURIComponent(String(animalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;
            const localVarFormParams = new URLSearchParams();

            // authentication api_key_query required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("api_key_query")
                    : await configuration.apiKey;
                localVarQueryParameter["api_key_query"] = localVarApiKeyValue;
            }


            if (name !== undefined) { 
                localVarFormParams.set('name', name as any);
            }

            if (status !== undefined) { 
                localVarFormParams.set('status', status as any);
            }
            localVarHeaderParameter['Content-Type'] = 'application/x-www-form-urlencoded';
            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                query.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = localVarFormParams.toString();

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * AnimalApi - functional programming interface
 * @export
 */
export const AnimalApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Add a new animal to the store
         * @param {Animal} body Animal object that needs to be added to the store
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async addAnimal(body: Animal, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await AnimalApiAxiosParamCreator(configuration).addAnimal(body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Deletes a animal
         * @param {number} animalId Animal id to delete
         * @param {string} [apiKey] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteAnimal(animalId: number, apiKey?: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await AnimalApiAxiosParamCreator(configuration).deleteAnimal(animalId, apiKey, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * Returns a single animal
         * @summary Find animal by ID
         * @param {number} animalId ID of pet to return
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getAnimalById(animalId: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Animal>> {
            const localVarAxiosArgs = await AnimalApiAxiosParamCreator(configuration).getAnimalById(animalId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Update an existing animal
         * @param {Animal} body Animal object that needs to be added.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateAnimal(body: Animal, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await AnimalApiAxiosParamCreator(configuration).updateAnimal(body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Updates a animal
         * @param {number} animalId ID of animal that needs to be updated
         * @param {string} [name] 
         * @param {string} [status] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateAnimalWithForm(animalId: number, name?: string, status?: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await AnimalApiAxiosParamCreator(configuration).updateAnimalWithForm(animalId, name, status, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * AnimalApi - factory interface
 * @export
 */
export const AnimalApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Add a new animal to the store
         * @param {Animal} body Animal object that needs to be added to the store
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        addAnimal(body: Animal, options?: any): AxiosPromise<void> {
            return AnimalApiFp(configuration).addAnimal(body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Deletes a animal
         * @param {number} animalId Animal id to delete
         * @param {string} [apiKey] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteAnimal(animalId: number, apiKey?: string, options?: any): AxiosPromise<void> {
            return AnimalApiFp(configuration).deleteAnimal(animalId, apiKey, options).then((request) => request(axios, basePath));
        },
        /**
         * Returns a single animal
         * @summary Find animal by ID
         * @param {number} animalId ID of pet to return
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAnimalById(animalId: number, options?: any): AxiosPromise<Animal> {
            return AnimalApiFp(configuration).getAnimalById(animalId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update an existing animal
         * @param {Animal} body Animal object that needs to be added.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateAnimal(body: Animal, options?: any): AxiosPromise<void> {
            return AnimalApiFp(configuration).updateAnimal(body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Updates a animal
         * @param {number} animalId ID of animal that needs to be updated
         * @param {string} [name] 
         * @param {string} [status] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateAnimalWithForm(animalId: number, name?: string, status?: string, options?: any): AxiosPromise<void> {
            return AnimalApiFp(configuration).updateAnimalWithForm(animalId, name, status, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * AnimalApi - object-oriented interface
 * @export
 * @class AnimalApi
 * @extends {BaseAPI}
 */
export class AnimalApi extends BaseAPI {
    /**
     * 
     * @summary Add a new animal to the store
     * @param {Animal} body Animal object that needs to be added to the store
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AnimalApi
     */
    public addAnimal(body: Animal, options?: any) {
        return AnimalApiFp(this.configuration).addAnimal(body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Deletes a animal
     * @param {number} animalId Animal id to delete
     * @param {string} [apiKey] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AnimalApi
     */
    public deleteAnimal(animalId: number, apiKey?: string, options?: any) {
        return AnimalApiFp(this.configuration).deleteAnimal(animalId, apiKey, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * Returns a single animal
     * @summary Find animal by ID
     * @param {number} animalId ID of pet to return
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AnimalApi
     */
    public getAnimalById(animalId: number, options?: any) {
        return AnimalApiFp(this.configuration).getAnimalById(animalId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Update an existing animal
     * @param {Animal} body Animal object that needs to be added.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AnimalApi
     */
    public updateAnimal(body: Animal, options?: any) {
        return AnimalApiFp(this.configuration).updateAnimal(body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Updates a animal
     * @param {number} animalId ID of animal that needs to be updated
     * @param {string} [name] 
     * @param {string} [status] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AnimalApi
     */
    public updateAnimalWithForm(animalId: number, name?: string, status?: string, options?: any) {
        return AnimalApiFp(this.configuration).updateAnimalWithForm(animalId, name, status, options).then((request) => request(this.axios, this.basePath));
    }
}
